/* GCC */
#include <fstream>
#include <utility>
std::pair<long, long>* rt = 0;
long** res = 0;
int n = 0, currX = 0, currY = 0;
bool* used = 0;
bool solve(const std::pair<long, long>& needed)
{
        if(needed.first == 0 || needed.second == 0)
                return true;
        else if(needed.first < 0 || needed.second < 0)
                return false;
        for(int i = 0; i < n; i++)
        {
                if(used[i])
                       continue;
                if(rt[i].first == needed.first)
                {
                       res[i][0] = currX;
                       res[i][1] = currY;
                       currY += rt[i].second;
                       res[i][2] = i + 1;
                       res[i][3] = 0;
                       used[i] = true;
                       if(solve(std::make_pair(needed.first, needed.second - rt[i].second)))
                               break;
                       used[i] = false;
                       currY -= rt[i].second;
                }
                if(rt[i].first == needed.second)
                {
                       res[i][0] = currX;
                       res[i][1] = currY;
                       currX += rt[i].second;
                       res[i][2] = i + 1;
                       res[i][3] = 1;
                       used[i] = true;
                       if(solve(std::make_pair(needed.first - rt[i].second, needed.second)))
                               break;
                       currX -= rt[i].second;
                }
                if(rt[i].second == needed.second)
                {
                       res[i][0] = currX;
                       res[i][1] = currY;
                       currX += rt[i].first;
                       res[i][2] = i + 1;
                       res[i][3] = 0;
                       used[i] = true;
                       if(solve(std::make_pair(needed.first - rt[i].first, needed.second)))
                               break;
                       currX -= rt[i].first;
                }
                if(rt[i].second == needed.first)
                {
                       res[i][0] = currX;
                       res[i][1] = currY;
                       currY += rt[i].first;
                       res[i][2] = i + 1;
                       res[i][3] = 1;
                       used[i] = true;
                       if(solve(std::make_pair(needed.first, needed.second - rt[i].first)))
                               break;
                       currY -= rt[i].first;
                }
                if(i == n)
                       return false;
        }
        return true;
}
int main(void)
{
    std::pair<long, long> needed;
    std::ifstream in("rectang.in");
    in >> n;
    rt = new std::pair<long, long>[n];
    res = new long*[n];
    used = new bool[n];
    for(int i = 0; i < n; i++)
    {
            used[i] = false;
            res[i] = new long[4];
            in >> rt[i].first >> rt[i].second;
    }
    in >> needed.first >> needed.second;
    in.close();
    long sum = 0;
    for(int i = 0; i < n; i++)
            sum += (rt[i].first * rt[i].second);
    std::ofstream out("rectang.out");
    if(sum != needed.first * needed.second)
            out << "No solution";
    else
    {
        bool good = solve(needed);
        if(good)
        {
        for(int i = 0; i < n; i++)
                for(int j = 0; j < 4; j++)
                        out << res[i][j] << ' ';
        }
        else
            out << "No solution";
    }
    out << '\n';
    out.close();
    for(int i = 0; i < n; i++)
            delete[] res[i];
    delete[] res;
    delete[] rt;
    delete[] used;
    return 0;
}
