/* GCC */
#include <iostream>
#include <math.h>
using namespace std;
const double pi = 3.14159265358979323846;
double s;
class vector
{
      public:
             double x,y,z;
};
vector v[3],r[2];
void readf(int j)
{
     int a,b,c;
     cin >> a >> b >> c;
     double alpha,beta;
     alpha = pi*(a+(b/60.0)+(c/3600.0))/180.0;
     cin >> a >> b >> c;
     beta = pi*(a+(b/60.0)+(c/3600.0))/180.0;
     v[j].x=cos(alpha)*cos(beta);
     v[j].y=cos(alpha)*sin(beta);
     v[j].z=sin(alpha);
}
vector vpr(vector a,vector b)
{
     vector k;
     k.x=a.y*b.z+a.z*b.y;
     k.y=a.x*b.z+a.z*b.x;
     k.z=a.x*b.y+a.y*b.x;
     return k;
}
double spr(vector a,vector b)
{
     return a.x*b.x+a.y*b.y+a.z*b.z;
}
double length(vector a)
{
       return sqrt(a.x*a.x+a.y*a.y+a.z*a.z);
}
void add()
{
     vector u,w,p;
     double a,b,c;
     a=spr(v[1],v[0]);
     b=spr(v[1],v[1]);
     c=spr(v[1],v[2]);
     u.x=a*v[0].x-b*v[1].x;
     w.x=a*v[2].x-c*v[1].x;
     u.y=a*v[0].y-b*v[1].y;
     w.y=a*v[2].y-c*v[1].y;
     u.z=a*v[0].z-b*v[1].z;
     w.z=a*v[2].z-c*v[1].z;     
     //u=vpr(vpr(v[1],v[0]),v[1]);
     //w=vpr(vpr(v[1],v[2]),v[1]);
     p=vpr(u,w);
     a=spr(u,w)/length(w);
     b=spr(u,w)/length(p);     
     s+=atan2(length(vpr(w,u)),spr(w,u));
}
int main()
{
    freopen("riman2.in","r",stdin);
    freopen("riman2.out","w",stdout);
    s = 2*pi;
    readf(0);
    r[0]=v[0];
    readf(1);
    r[1]=v[1];
    while (!(cin.eof()))
    {
          readf(3);
          add();
          v[0]=v[1];
          v[1]=v[2];
    }
    v[2]=r[0];
    add();
    v[0]=v[1];
    v[1]=v[2]; 
    v[2]=r[1];
    add();  
    printf("%1.9lf\n",s/(4*pi-s));
    fclose(stdin);
    fclose(stdout);
    return 0;
}
