/* GCC */
#include <list>
#include <math.h>
#include <vector>
#include <iostream>
#include <algorithm>

#define Ri(a) scanf("%d", &a)
#define Ri2(a,b) scanf("%d%d", &a, &b)
#define Wi(a) printf("%d ", a)
#define Wi2(a,b) printf("%d %d ", a, b)
#define Wie(a) printf("%d\n", a)
#define Wie2(a,b) printf("%d %d\n", a, b)
#define F first
#define S second
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for( int i = (a), ___n = (b); i <= ___n; i++ )
#define FORD(i,a,b) for( int i = (a), ___n = (b); i >= ___n; i-- )
#define forn(i,n) FOR(i,0,(n)-1)

using namespace std;

struct rect {
       int x, y;
       
       rect( int x, int y ): x(x), y(y) {}
};

struct edge {
       int y1, y2, h;
       
       void ed( int y1_, int y2_, int h_ )
       { 
            y1 = y1_, y2 = y2_, h = h_  ;
       }
};

int n, N, M, ans[100], ans_s = 0;
vector < rect > r;
//vector < edge > lst;
edge lst[100];
int lst_sz = 0;
bool used[100];


inline void push( int x ) {
     ans[ans_s++] = x;
}

inline void pop() {
       ans_s--;
}

bool no = 1;
void viv() {
     no = 0;
     ans_s--;
     forn( i, ans_s ) Wi( ans[i] );
     Wie( ans[ans_s++] );
}

void push_back( edge x ) {
     lst[lst_sz++] = x;
}

void resize( int sz ) {
     lst_sz = sz;
}

void insert( int p, edge val )
{
     resize( lst_sz + 1 );
     lst[lst_sz - 1] = val;
     for( int i = lst_sz - 1; i - 1 > p; i-- ) swap( lst[i], lst[i - 1] );
}

void erase( int p )
{
     for( int i = p; i + 1 < lst_sz; i++ ) swap( lst[i], lst[i + 1] );
     resize( lst_sz - 1 );
}

void work( ) {
     
     int mn_h = 2000000000;
     int mn;
     for( int i = 0; i < lst_sz; i++ ) {
           if( lst[i].h < mn_h ) mn_h = lst[i].h, mn = i;
     }
     
     bool smt = 0;
     forn( p, n ) {
           if( used[p] ) continue;
           smt = 1;
     forn( i, 2 ) {
           if( lst[mn].h + r[p].x <= M && lst[mn].y2 - lst[mn].y1 >= r[p].y ) {
               if( lst[mn].y2 - lst[mn].y1 == r[p].y ) {
                   push( lst[mn].h );
                   push( lst[mn].y1 );
                   push( p + 1 );
                   push( i );
                   used[p] = 1;
             
                   lst[mn].h += r[p].x;
                   work();
                   lst[mn].h -= r[p].x;
             
                   used[p] = 0;
                   pop();pop();pop();pop();
               } else {
                      push( lst[mn].h );
                      push( lst[mn].y1 );
                      push( p + 1 );
                      push( i );  
                      used[p] = 1;            
                      
                      int y2 = lst[mn].y2;
                      int next = mn + 1;
                      insert( mn, lst[mn] );
                      lst[next].y1 += r[p].y;
                      lst[mn].y2 = lst[next].y1;
                      lst[mn].h += r[p].x;
                      work();
                      lst[mn].h -= r[p].x;
                      lst[mn].y2 = y2;
                      erase( next );
                      
                      used[p] = 0;
                      pop();pop();pop();pop();
                }
           }
           swap( r[p].x, r[p].y );
     }
     }
     if( !smt ) viv();
     return;
}

int main() {
    freopen("rectang.in", "r", stdin);
    freopen("rectang.out", "w", stdout);
    memset( used, 0, 100 );
    Ri(n);
    
    int a, b;
    long long s = 0;
    forn( i, n ) {
          Ri2( a, b );
          r.pb( rect( a, b ) );
          s += a * b;
    }
    
    Ri2( M, N );
    if( N * M != s ) {
        cout << "No solution\n";
        return 0;
    }
    {
        int n_ = N, m_ = M;
        if( n_ > m_ ) swap(n_, m_);
        forn( i, n ) {
              if( min( r[i].x, r[i].y ) > n_ || max( r[i].x, r[i].y ) > m_ ) {
                  cout << "No solution\n";
                  return 0;
              }
        }
    }
    
    edge wtf;
    wtf.ed( 0, N, 0 );
    pb( wtf );
    //wtf.ed( N, N + 1, 2000000000 );
    //pb( wtf );
    work();
    if( no ) {
        cout << "No solution\n";
        return 0;
    }
    fclose(stdin);
    fclose(stdout);
    return 0;
}
